<?php
ini_set('include_path', ini_get('include_path') . ':/usr/local/lib/php');

require_once 'Smarty/Smarty.class.php';
require_once 'AmalgamateClasses/Amalgamate.php';

try {
    $dbh = new MisterData(sprintf('pgsql:host=%s;dbname=%s', 'localhost', 'amalgamate'), 'amalgamate');
} catch (PDOException $e) {
    die($e->getMessage());
}

$amalgamate =& new Amalgamate($dbh);

$tmpl =& new Smarty;
$tmpl->compile_dir = 'AmalgamateTemplates/ctemplates';
$tmpl->template_dir = 'AmalgamateTemplates';

switch ($_GET['op']) {
case 'manage':
    switch ($_GET['cmd']) {
    case 'deletefeed':
	try {
	    $feed =& new AmalgamateFeed($dbh, $_GET['feedid']);
	    $feed->delete();
	    header("location:index.php?op=manage");
	    exit;
	} catch (PDOException $e) {
	    $tmpl->assign_by_ref('e', $e);
	    $tmpl->assign('body', 'error.html');
	}
	break;
    case 'savefeed':
	try {
	    $feed =& new AmalgamateFeed($dbh, $_POST['feedid']);
	    $feed->active = 't';
	    $feed->name = $_POST['name'];
	    $feed->url = $_POST['url'];
	    $feed->category = $_POST['category'];
	    if (!$_POST['newsource']) {
		$feed->source = $_POST['source'];
	    } else {
		$amalgamate->saveSource($_POST['newsource'], $_POST['newsourcelink']);
		$feed->source = $_POST['newsource'];
	    }
	    $feed->save();
	    header('location:index.php?op=manage&feedid=' . $feed->feedid);
	    exit;
	} catch (PDOException $e) {
	    $tmpl->assign_by_ref('e', $e);
	    $tmpl->assign('body', 'error.html');
	}
	break;
    default:
	try {
	    $feed =& new AmalgamateFeed($dbh, $_GET['feedid']);
	    $tmpl->assign_by_ref('feed', $feed);
	    $feeds = $amalgamate->getFeeds();
	    $sources = $amalgamate->getSources();
	    $categories = $amalgamate->getCategories();
	    $tmpl->assign('cats', $categories);
	    $tmpl->assign('sources', $sources);
	    $tmpl->assign('feeds', $feeds);
	    $tmpl->assign('body', 'manage.html');
	} catch (PDOException $e) {
	    $tmpl->assign_by_ref('e', $e);
	    $tmpl->assign('body', 'error.html');
	}
	break;
    }
    break;
case 'refresh':
    try {
	$amalgamate->refresh();
	header("location:index.php");
	exit;
    } catch (PDOException $e) {
	$tmpl->assign_by_ref('e', $e);
	$tmpl->assign('body', 'error.html');
    }
    break;
case 'feedstories':
    try {
	$feed =& new AmalgamateFeed($dbh, $_GET['feedid']);
	$stories = $feed->getStories(100);
	$tmpl->assign_by_ref('feed', $feed);
	$tmpl->assign('stories', $stories);
	$tmpl->assign('body', 'feed_stories.html');
    } catch (PDOException $e) {
	$tmpl->assign_by_ref('e', $e);
	$tmpl->assign('body', 'error.html');
    }
    break;
default:
    try {
	$stories = $amalgamate->getStories(50);
	$tmpl->assign('stories', $stories);
	$tmpl->assign('body', 'home.html');
    } catch (PDOException $e) {
	$tmpl->assign_by_ref('e', $e);
	$tmpl->assign('body', 'error.html');
    }
    break;
}

$tmpl->display('wrap.html');
?>
